(function (exports) {
'use strict';

var ComscoreStreamsense = function (_akamai$amp$Plugin) {
  babelHelpers.inherits(ComscoreStreamsense, _akamai$amp$Plugin);

  function ComscoreStreamsense(player, config) {
    babelHelpers.classCallCheck(this, ComscoreStreamsense);

    var _this = babelHelpers.possibleConstructorReturn(this, (ComscoreStreamsense.__proto__ || Object.getPrototypeOf(ComscoreStreamsense)).call(this, player, config));

    _this.sdk = window.ns_ || ns_;

    if (!_this.sdk) _this.logger.log("[AMP ComscoreStreamsense Event] SDK not found or cannot be initialized");
    return _this;
  }

  babelHelpers.createClass(ComscoreStreamsense, [{
    key: "onready",
    value: function onready() {
      this.bindHandlers(["stop", "onadstarted", "onaderror"]);
      this.player.addEventListener("adstarted", this.onadstarted);
      this.player.addEventListener("adended", this.stop);
      this.player.addEventListener("adskipped", this.stop);
      this.player.addEventListener("aderror", this.onaderror);
    }
  }, {
    key: "createStreamingTag",
    value: function createStreamingTag() {
      if (this.streamingTag != null) this.streamingTag.stop();
      this.streamingTag = null;
      this.streamingTag = new ns_.ReducedRequirementsStreamingAnalytics({ publisherId: this.config.clientId });
    }

    /* Get MetaData */

  }, {
    key: "getMetaData",
    value: function getMetaData() {
      var ads = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;

      var metadata = {};
      var object = ads ? this.data.metadata.ads : this.data.metadata.video;
      for (var key in object) {
        var value = object[key];
        if (value == "null" || value == null) continue;
        metadata[key] = value;
      }
      return metadata;
    }
  }, {
    key: "onmediachange",
    value: function onmediachange() {
      this.createStreamingTag();
      this.logger.log("[AMP ComscoreStreamsense Event] Media Change, StreamTag ReInitialize");
    }

    /* Media Started */

  }, {
    key: "onplaying",
    value: function onplaying() {
      /* Play Beacon */
      var ads = this.player.ads;
      if (ads != null && (ads.getInProgress() || ads.inProgress) || this.streamingTag == null) return;
      this.streamingTag.playVideoContentPart(this.getMetaData());
      this.logger.log("[AMP ComscoreStreamsense Event] Content Play");
    }
  }, {
    key: "onpaused",
    value: function onpaused() {
      var ads = this.player.ads;
      if (ads != null && (ads.getInProgress() || ads.inProgress)) return;
      this.stop();
    }

    /* Media Stop */

  }, {
    key: "stop",
    value: function stop() {
      this.streamingTag.stop();
      this.logger.log("[AMP ComscoreStreamsense Event] Stop");
    }

    /* Media Ended */

  }, {
    key: "onended",
    value: function onended() {
      /* MediaStop Ended */
      this.stop();
      this.logger.log("[AMP ComscoreStreamsense Event] End");
    }
  }, {
    key: "onadstarted",
    value: function onadstarted() {
      this.streamingTag.playVideoAdvertisement(this.getMetaData(true));
      this.logger.log("[AMP ComscoreStreamsense Event] : Ad Start");
    }
  }, {
    key: "onaderror",
    value: function onaderror() {
      this.onadstarted();
      this.stop();
    }
  }]);
  return ComscoreStreamsense;
}(akamai.amp.Plugin);

akamai.amp.AMP.registerPlugin("comscorestreamsense", akamai.amp.Plugin.createFactory(ComscoreStreamsense));

exports.ComscoreStreamsense = ComscoreStreamsense;

}((this.akamai.amp.comscorestreamsense = this.akamai.amp.comscorestreamsense || {})));
//# sourceMappingURL=Comscorestreamsense.js.map
